;******************************
;* Program Demo GLCD DV128064 *
;* Display Character Thai,Eng *
;* Assembler : A180Z          *
;* Hardware  : CP-JR180 V2.0  *
;* BY...ETT CO.,LTD.(14/7/97) *
;******************************

            .ORG     8000H

;FOR LCD
            .EQU     LCDCTRL1,0C0H
            .EQU     LCDCTRL2,0C1H
            .EQU     LCDDATA1,0C2H
            .EQU     LCDDATA2,0C3H
            .EQU     LCDREAD1,0C4H
            .EQU     LCDREAD2,0C5H
;
            .EQU     DISPON,3FH
            .EQU     DISPOFF,3EH
            .EQU     STARTLN0,0C0H
            .EQU     LINE1,0B8H
            .EQU     LINE2,0B9H
            .EQU     LINE3,0BAH
            .EQU     LINE4,0BBH
            .EQU     LINE5,0BCH
            .EQU     LINE6,0BDH
            .EQU     LINE7,0BEH
            .EQU     LINE8,0BFH
            .EQU     STARTCL0,40H
            .EQU     SYSCAL,10H
;
; ********** POWER-UP **********
POWER:      LD    HL,10         ; POWER-UP DELAY IF RUN START RUN 1000H
POWER1:     DEC   HL
            LD    A,0
POWER2:     DEC   A
            JP    NZ,POWER2
            LD    A,L
            OR    H
            JP    NZ,POWER1
            ;
RUN:        CALL INITLCD        ;INIT GLCD SET DISPLAY ON
            CALL CLRSCR         ;CLS SCREEN GLCD PADG1,PAGE2
            CALL TITLE          ;DISPLAY PAGE1=ENG,PAGE2=THAI
            ;
            HALT                ;STOP PROGRAM
;
;******* DISPLAY ENG AND THAI *******
;
TITLE:      LD   HL,BLANK   ;ENG
            CALL PAGE1
            LD   A,LINE1
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE2
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE3
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE4
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE5
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE6
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE7
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE8
            CALL GOTOLINE
            CALL DISP8
            ;
            LD   HL,KAI      ;THAI
            CALL PAGE2
            LD   A,LINE1
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE2
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE3
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE4
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE5
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE6
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE7
            CALL GOTOLINE
            CALL DISP8
            LD   A,LINE8
            CALL GOTOLINE
            CALL DISP8
            RET
;
DISP8:      LD   B,8
DISP8_1:    LD   (STBMAP),HL
            CALL DISPLAY
            LD   DE,0008H
            ADD  HL,DE
            DEC  B
            JP   NZ,DISP8_1
            RET

;*********** GOTO LINE# COL 1 ************
;    SET LINE #
;    INPUT LINE REG (A)
;
GOTOLINE:   PUSH AF
            LD   A,(CPORT)
            LD   C,A
            POP  AF
            OUT  (C),A
            CALL WBF
            LD   A,STARTCL0
            OUT  (C),A
            RET

;*********** SET PAGE USER 1 ******
;
PAGE1:      PUSH AF
            LD   A,LCDCTRL1
            LD   (CPORT),A
            LD   A,LCDDATA1
            LD   (DPORT),A
            LD   A,LCDREAD1
            LD   (RPORT),A
            POP  AF
            RET

;*********** SET PAGE USER 2 ******
;
PAGE2:      PUSH AF
            LD   A,LCDCTRL2
            LD   (CPORT),A
            LD   A,LCDDATA2
            LD   (DPORT),A
            LD   A,LCDREAD2
            LD   (RPORT),A
            POP  AF
            RET

; ******* CLEAR SCREEN **************
;   CLEAR SCREEN PAGE1,PAGE2
;
CLRSCR:     PUSH AF
            CALL PAGE1
            LD   A,STARTLN0
            CALL GOTOLINE
            CALL CLEAR
            CALL PAGE2
            LD   A,STARTLN0
            CALL GOTOLINE
            CALL CLEAR
            POP AF
            RET

; ******* CLEAR SCREEN************
; SUB PROGRAM CLRSCR
CLEAR:      PUSH DE
            PUSH BC
            PUSH AF
            LD E,LINE1
            LD D,08H
ANOTHER:    LD A,(CPORT)
            LD C,A
            LD A,E
            CALL WBF
            OUT (C),A
            LD   B,48H
            LD   A,(DPORT)
            LD   C,A
LLC:        LD   A,00H
            OUT  (C),A
            CALL WBF
            DEC  B
            JP   NZ,LLC
            INC  E
            DEC  D
            LD   A,00H
            CP   D
            JP   NZ,ANOTHER
            POP  AF
            POP  BC
            POP  DE
            RET

; *********** INIT  LCD ***********
;
INITLCD:    CALL PAGE1
            LD   A,(CPORT)
            LD   C,A
            LD   A,DISPON
            OUT  (C),A
            CALL WBF
            LD   A,STARTLN0
            OUT  (C),A
            CALL WBF
            CALL PAGE2
            LD   A,(CPORT)
            LD   C,A
            LD   A,DISPON
            OUT  (C),A
            CALL WBF
            LD   A,STARTLN0
            OUT  (C),A
            CALL WBF
            RET

; *********** CHECK BUSY FLAG LCD *********
;
WBF:        PUSH AF
            PUSH BC
BUSY1:      LD   A,(RPORT)
            LD   C,A
            IN   A,(C)
            NOP
            BIT  7,A
            JP   NZ,BUSY1
            POP  BC
            POP  AF
            RET

;************* DISPLAY LCD ONE CHAR ***********
;   DISPLAY ONE CHAR = 8 BYTE
;   INPUT DATA  = (STBMAP)
;
DISPLAY:    PUSH AF
            PUSH BC
            PUSH IX
            LD   IX,(STBMAP)
            LD   B,08H
            LD   A,(DPORT)
            LD   C,A
OUTDAT:     LD   A,(IX+0)
            OUT  (C),A
            CALL WBF
            INC  IX
            DEC  B
            JP   NZ,OUTDAT
            POP  IX
            POP  BC
            POP  AF
            RET

;****************
;* Font English *
;****************
;
BLANK:      .DB 00H,00H,00H,00H ;BLANK
            .DB 00H,00H,00H,00H
TOKJAI:     .DB 00H,00H,0EH,0BFH ;!
            .DB 0EH,00H,00H,00H
KUMPUD:     .DB 00H,00H,07H,00H  ; "
            .DB 07H,00H,00H,00H
NUMBER:     .DB 00H,24H,0FFH,24H ; #
            .DB 24H,0FFH,24H,00H
DOLLAR:     .DB 08H,54H,54H,0FEH ; $
            .DB 54H,54H,20H,00H
PERCENT:    .DB 86H,46H,20H,10H  ; %
            .DB 08H,0C4H,0C2H,00H
AMPER:      .DB 60H,94H,8EH,9AH  ; &
            .DB 6EH,44H,0B0H,80H
APOS:       .DB 00H,00H,00H,05H  ; '
            .DB 03H,00H,00H,00H
WOPEN:      .DB 00H,00H,3CH,42H  ; (
            .DB 81H,00H,00H,00H
WCLOSE:     .DB 00H,00H,00H,81H  ; )
            .DB 42H,3CH,00H,00H
STAR:       .DB 00H,08H,2AH,1CH ; *
            .DB 1CH,2AH,08H,00H
PLUS:       .DB 00H,08H,08H,3EH ; +
            .DB 3EH,08H,08H,00H
COMMA:      .DB 00H,00H,00H,0A0H ;,
            .DB 60H,00H,00H,00H
MINUS:      .DB 00H,08H,08H,08H ; -
            .DB 08H,08H,08H,00H
STOP:       .DB 00H,00H,00H,0C0H ;.
            .DB 0C0H,00H,00H,00H
SLASH:      .DB 00H,0C0H,30H,18H ;/
            .DB 0CH,03H,00H,00H
ZERO:       .DB 00H,7CH,0A2H,0B2H; 0
            .DB 9AH,8AH,7CH,00H
ONE:        .DB 00H,00H,82H,0FFH ; 1
            .DB 80H,00H,00H,00H
TWO:        .DB 00H,86H,0C1H,0A1H ; 2
            .DB 91H,89H,86H,00H
THREE:      .DB 00H,42H,81H,89H   ; 3
            .DB 89H,89H,76H,00H
FOUR:       .DB 60H,50H,48H,44H   ;4
            .DB 42H,0FFH,40H,00H
FIVE:       .DB 5FH,85H,85H,85H   ; 5
            .DB 85H,49H,30H,00H
SIX:        .DB 00H,7CH,92H,89H   ; 6
            .DB 89H,89H,70H,00H
SEVEN:      .DB 00H,03H,01H,0C1H  ;7
            .DB 31H,0DH,03H,00H
EIGHT:      .DB 00H,76H,89H,89H  ;8
            .DB 89H,89H,76H,00H
NINE:       .DB 00H,0EH,91H,91H ;9
            .DB 91H,49H,3EH,00H
COLON:      .DB 00H,00H,00H,66H ; :
            .DB 66H,00H,00H,00H
SEMI:       .DB 00H,00H,80H,76H ; ;
            .DB 36H,00H,00H,00H
LESS:       .DB 00H,00H,18H,24H ; <
            .DB 42H,81H,00H,00H
EQUAL:      .DB 00H,24H,24H,24H ; =
            .DB 24H,24H,00H,00H
MORE:       .DB 00H,00H,81H,42H ; >
            .DB 24H,18H,00H,00H
QUES:       .DB 00H,06H,09H,0DH ; ?
            .DB 0B5H,09H,06H,00H
ATAB:       .DB 0F8H,14H,12H,11H ; A
            .DB 12H,14H,0F8H,00H
BTAB:       .DB 81H,0FFH,89H,89H ; B
            .DB 89H,89H,76H,00H
CTAB:       .DB 00H,3CH,42H,81H  ; C
            .DB 81H,81H,42H,00H
DTAB:       .DB 81H,0FFH,81H,81H ; D
            .DB 81H,42H,3CH,00H
ETAB:       .DB 81H,0FFH,89H,89H ; E
            .DB 9DH,81H,0E3H,00H
FTAB:       .DB 81H,0FFH,89H,09H ; F
            .DB 1DH,01H,03H,00H
GTAB:       .DB 00H,7EH,81H,81H  ; G
            .DB 91H,51H,0F6H,00H
HTAB:       .DB 00H,0FFH,08H,08H ; H
            .DB 08H,08H,0FFH,00H
ITAB:       .DB 00H,00H,81H,0FFH ; I
            .DB 81H,00H,00H,00H
JTAB:       .DB 00H,40H,80H,80H  ; J
            .DB 81H,7FH,01H,00H
KTAB:       .DB 81H,0FFH,89H,14H ; K
            .DB 22H,0C1H,81H,80H
LTAB:       .DB 00H,81H,0FFH,81H ; L
            .DB 80H,80H,0C0H,00H
MTAB:       .DB 0FFH,02H,04H,18H ; M
            .DB 04H,02H,0FFH,00H
NTAB:       .DB 81H,0FFH,83H,0CH ; N
            .DB 18H,61H,0FFH,01H
OTAB:       .DB 00H, 7EH,81H,81H ; O
            .DB 81H,81H,7EH,00H
PTAB:       .DB 00H,81H,0FEH,91H ; P
            .DB 11H,11H,0EH,00H
QTAB:       .DB 00H,7EH,81H,91H  ; Q
            .DB 0A1H,0C1H,7FH,80H
RTAB:       .DB 81H,0FFH,89H,19H ; R
            .DB 29H,0C9H,86H,80H
STAB:       .DB 00H,0E6H,49H,89H ; S
            .DB 91H,92H,67H,00H
TTAB:       .DB 03H,01H,81H,0FFH ; T
            .DB 81H,01H,03H,00H
UTAB:       .DB 01H,7FH,81H,80H ; U
            .DB 80H,81H,7FH,01H
VTAB:       .DB 07H,18H,60H,80H ; V
            .DB 60H,18H,0FH,00H
WTAB:       .DB 3FH,0C0H,20H,10H ; W
            .DB 20H,0C0H,3FH,00H
XTAB:       .DB 0C3H,27H,18H,18H ; X
            .DB 18H,27H,0C3H,00H
YTAB:       .DB 01H,03H,84H,0F8H ; Y
            .DB 84H,03H,01H,00H
ZTAB:       .DB 0C3H,0A1H,91H,89H ; Z
            .DB 85H,83H,0C1H,00H

;******************
;* Character Thai *
;******************
;
KAI:        .DB 00H,0FAH,05H,01H
            .DB 01H,01H,0FEH,00H
KHAI:       .DB 00H,02H,05H,0FEH
            .DB 80H,7FH,00H,00H
BUFFALO:    .DB 0FEH,21H,11H,29H
            .DB 11H,01H,0FEH,00H
RAKANG:     .DB 62H,95H,0F2H,29H
            .DB 46H,80H,0FFH,00H
NGU:        .DB 00H,10H,20H,42H
            .DB 85H,0FEH,00H,00H
JAN:        .DB 02H,01H,09H,15H
            .DB 79H,81H,0FEH,00H
CHING:      .DB 12H,0E9H,0B1H,41H
            .DB 21H,0FEH,0A0H,40H
CHANG:      .DB 04H,0F2H,8AH,86H
            .DB 84H,0FAH,01H,01H
SOO:        .DB 02H,05H,02H,0FDH
            .DB 82H,7DH,00H,00H
CHER:       .DB 7AH,0A5H,41H,41H
            .DB 0A1H,7EH,40H,0FFH
YING:       .DB 7AH,0A5H,41H,01H
            .DB 0FEH,80H,80H,0FFH
YINGLOW:    .DB 00H,00H,00H,00H
            .DB 06H,06H,04H,02H
CHADA:      .DB 42H,0A5H,79H,01H
            .DB 01H,01H,0FEH,80H
CHADALOW:   .DB 00H,00H,02H,05H
            .DB 02H,05H,07H,00H
PATAK:      .DB 42H,0A5H,79H,01H
            .DB 81H,01H,0FEH,00H
PATAKLOW:   .DB 02H,05H,02H,05H
            .DB 02H,04H,07H,00H
TORTAN:     .DB 00H,02H,15H,2DH
            .DB 0F5H,85H,7AH,01H
TORTANLOW:  .DB 10H,28H,10H,28H
            .DB 14H,2AH,1EH,00H
MONTO:      .DB 02H,0E5H,12H,09H
            .DB 06H,02H,0FFH,00H
TORTHOA:    .DB 0FEH,11H,2AH,52H
            .DB 0A2H,7EH,40H,0BFH
NANE:       .DB 7AH,0A5H,41H,0FEH
            .DB 40H,0FFH,0A0H,40H
DEK:        .DB 0FEH,81H,49H,35H
            .DB 19H,01H,0FEH,00H
TORTOA:     .DB 0FEH,81H,49H,36H
            .DB 19H,01H,0FEH,00H
TUNG:       .DB 7AH,0A5H,41H,01H
            .DB 01H,01H,0FEH,00H
TAHAN:      .DB 02H,0F5H,0EH,04H
            .DB 02H,01H,0FEH,00H
TONG:       .DB 00H,02H,05H,0FDH
            .DB 85H,85H,0FAH,01H
HNOO:       .DB 02H,0F5H,8EH,40H
            .DB 20H,0FFH,0A0H,40H
BAIMAI:     .DB 02H,85H,0FEH,80H
            .DB 80H,80H,0FFH,00H
PLARHIGH:   .DB 00H,00H,00H,00H
            .DB 00H,00H,0F0H,00H
PLAR:       .DB 02H,05H,0FEH,80H
            .DB 80H,80H,0FFH,00H
PUNG:       .DB 00H,7EH,85H,42H
            .DB 40H,80H,7EH,00H
PHAHIGH:    .DB 00H,00H,00H,00H
            .DB 00H,00H,0F0H,00H
PHA:        .DB 00H,7EH,85H,42H
            .DB 40H,80H,7FH,00H
PAN:        .DB 02H,05H,0FEH,40H
            .DB 30H,40H,0FFH,00H
FUNHIGH:    .DB 00H,00H,00H,00H
            .DB 00H,00H,0F0H,00H
FUN:        .DB 02H,05H,0FEH,40H
            .DB 30H,40H,0FFH,00H
POA:        .DB 42H,0A5H,79H,01H
            .DB 01H,01H,0FEH,00H
MAR:        .DB 42H,0A5H,0FEH,20H
            .DB 20H,40H,0FFH,00H
YAK:        .DB 00H,6EH,95H,92H
            .DB 80H,80H,0FFH,00H
SHIP:       .DB 00H,02H,05H,05H
            .DB 45H,0A5H,7AH,01H
LU:         .DB 00H,7AH,0A5H,41H
            .DB 01H,01H,0FEH,00H
LULOW:      .DB 00H,00H,00H,00H
            .DB 00H,00H,0FH,00H
LING:       .DB 02H,71H,0A9H,45H
            .DB 09H,11H,0FEH,00H
WAN:        .DB 00H,02H,01H,01H
            .DB 41H,0A1H,7EH,00H
SALAHIGH:   .DB 00H,00H,00H,00H
            .DB 00H,80H,50H,20H
SALA:       .DB 7EH,81H,79H,15H
            .DB 09H,01H,0FEH,00H
RUSI:       .DB 02H,85H,0FEH,80H
            .DB 98H,90H,0FFH,10H
TIGERHIGH:  .DB 00H,00H,00H,00H
            .DB 00H,80H,50H,20H
TIGER:      .DB 02H,71H,0A9H,45H
            .DB 09H,11H,0FEH,00H
HEEP:       .DB 02H,0FDH,26H,10H
            .DB 0AH,0DH,0FAH,00H
JURAHIGH:   .DB 00H,00H,00H,00H
            .DB 40H,0A0H,0C0H,20H
JURA:       .DB 02H,0F5H,4EH,20H
            .DB 20H,40H,0FFH,00H
ANG:        .DB 00H,72H,0A9H,91H
            .DB 81H,81H,7EH,00H
HOOKHIGH:   .DB 00H,00H,00H,00H
            .DB 00H,00H,0A0H,40H
HOOK:       .DB 00H,72H,0ADH,95H
            .DB 83H,81H,7EH,00H
SARAA:      .DB 00H,66H,55H,0AAH
            .DB 88H,44H,22H,00H
TOAKUB:     .DB 00H,14H,14H,14H
            .DB 14H,14H,00H,00H
SARAAR:     .DB 00H,02H,01H,01H
            .DB 01H,01H,0FEH,00H
SARAUMHIGH: .DB 20H,50H,50H,20H
            .DB 00H,00H,00H,00H
SARAUM:     .DB 00H,02H,01H,01H
            .DB 01H,01H,0FEH,00H
SARAAA:     .DB 00H,7FH,0A0H,40H
            .DB 00H,00H,00H,00H
SARAAIR:    .DB 00H,7FH,0A0H,40H
            .DB 7FH,0A0H,40H,00H
SARAOHIGH:  .DB 10H,28H,0E8H,08H
            .DB 08H,08H,00H,00H
SARAO:      .DB 00H,00H,0FFH,0C0H
            .DB 00H,00H,00H,00H
MAIMOONHIGH: .DB 38H,34H,04H,0FCH
            .DB 00H,00H,00H,00H
MAIMOON:    .DB 00H,00H,00H,0FFH
            .DB 0C0H,00H,00H,00H
MALAIHIGH:  .DB 08H,10H,20H,10H
            .DB 0F8H,00H,00H,00H
MALAI:      .DB 00H,00H,00H,00H
            .DB 0FFH,0C0H,00H,00H
YAMOK:      .DB 00H,0F0H,0D0H,20H
            .DB 10H,10H,0F0H,00H
YAMOKLOW:   .DB 00H,00H,18H,04H
            .DB 02H,02H,01H,00H
PAIYAN:     .DB 08H,14H,10H,10H
            .DB 08H,04H,0FEH,00H
SARAU:      .DB 00H,00H,00H,00H
            .DB 04H,0AH,3CH,00H
SARAUU:     .DB 00H,00H,00H,04H
            .DB 0AH,3CH,20H,3EH
SARAI:      .DB 00H,30H,48H,48H
            .DB 48H,50H,60H,00H
SARAE:      .DB 30H,28H,28H,28H
            .DB 38H,3CH,00H,00H
SARAAU:     .DB 00H,03H,48H,48H
            .DB 48H,50H,68H,30H
SARAAUE:    .DB 00H,30H,48H,48H
            .DB 50H,58H,60H,78H
HUN:        .DB 00H,30H,68H,50H
            .DB 40H,40H,20H,10H
NAMFON:     .DB 00H,18H,24H,24H
            .DB 14H,08H,00H,00H
TAIKU:      .DB 70H,48H,28H,28H
            .DB 48H,68H,64H,00H
MAIAKE:     .DB 00H,00H,00H,00H
            .DB 00H,70H,00H,00H
MAITO:      .DB 00H,40H,68H,58H
            .DB 40H,40H,20H,10H
MAITEE:     .DB 78H,48H,10H,18H
            .DB 08H,78H,20H,1EH
JATAWA:     .DB 00H,00H,10H,10H
            .DB 7CH,10H,10H,00H
KARAN:      .DB 00H,70H,50H,10H
            .DB 10H,0CH,00H,00H
AKEUM:      .DB 00H,30H,48H,48H
            .DB 48H,30H,06H,00H
TOUM:       .DB 02H,36H,4CH,4CH
            .DB 4AH,31H,00H,00H
TEEUM:      .DB 06H,35H,4AH,49H
            .DB 4EH,34H,02H,01H
TAWAUM:     .DB 00H,30H,48H,4AH
            .DB 4AH,37H,02H,02H
AKEHAN:     .DB 70H,50H,70H,40H
            .DB 40H,4CH,20H,10H
TOHAN:      .DB 70H,52H,76H,44H
            .DB 44H,44H,22H,11H
TEEHAN:     .DB 70H,57H,75H,42H
            .DB 41H,47H,24H,17H
TAWAHAN:    .DB 70H,50H,74H,44H
            .DB 4EH,44H,20H,10H
AKEI:       .DB 00H,60H,50H,50H
            .DB 50H,50H,66H,00H
TOI:        .DB 00H,60H,52H,56H
            .DB 54H,54H,62H,01H
TEEI:       .DB 00H,6EH,5AH,54H
            .DB 52H,5EH,68H,07H
TAWAI:      .DB 00H,60H,50H,52H
            .DB 52H,57H,62H,02H
KARANI:     .DB 00H,60H,50H,50H
            .DB 50H,5CH,6AH,01H
AKEE:       .DB 60H,50H,50H,50H
            .DB 50H,50H,7BH,00H
TOE:        .DB 60H,52H,56H,54H
            .DB 54H,52H,79H,00H
TEEE:       .DB 6EH,5AH,54H,52H
            .DB 5EH,54H,7AH,01H
TAWAE:      .DB 60H,50H,52H,52H
            .DB 57H,52H,7AH,00H

;************
;* RAM AREA *
;************
;
CPORT:      .RS  1H
DPORT:      .RS  1H
RPORT:      .RS  1H
STBMAP:     .RS  2H

            .END
