;************************
;                       *
;     RTC SUBROUTINE    *
;                       *
;************************
;
         .EQU   RTC,0A0H
         .EQU   SEC1,RTC
         .EQU   SEC10,RTC+1
         .EQU   MIN1,RTC+2
         .EQU   MIN10,RTC+3
         .EQU   HOUR1,RTC+4
         .EQU   HOUR10,RTC+5
         .EQU   DAY1,RTC+6
         .EQU   DAY10,RTC+7
         .EQU   MON1,RTC+8
         .EQU   MON10,RTC+9
         .EQU   YEAR1,RTC+10
         .EQU   YEAR10,RTC+11

         .EQU   CREG_D,RTC+0DH
         .EQU   CREG_E,RTC+0EH
         .EQU   CREG_F,RTC+0FH

;******** SET CLOCK ********
;       OUTPUT  SEC   D
;               MIN   C
;               HOR   B
;               DAY   H
;               MON   L
;               YEAR  E
;
         .ORG  8000H
;
SETCK:   LD    A,D
         OUT   (SEC1),A
         CALL  SHIPL
         OUT   (SEC10),A
         LD    A,C
         OUT   (MIN1),A
         CALL  SHIPL
         OUT   (MIN10),A
         LD    A,B
         OUT   (HOUR1),A
         CALL  SHIPL
         OUT   (HOUR10),A
         LD    A,H
         OUT   (DAY1),A
         CALL  SHIPL
         OUT   (DAY10),A
         LD    A,L
         OUT   (MON1),A
         CALL  SHIPL
         OUT   (MON10),A
         LD    A,E
         OUT   (YEAR1),A
         CALL  SHIPL
         OUT   (YEAR10),A
         RET
;
;******** GET CLOCK ********
;       INPUT   SEC   D
;               MIN   C
;               HOR   B
;               DAY   L
;               MON   H
;               YEAR  E
;
GETCK:   IN   A,(SEC1)
         AND  0FH
         LD   B,A
         IN   A,(SEC10)
         CALL SHIFTRTC
         AND  0F0H
         ADD  A,B
         LD   D,A        ;SEC

         IN   A,(MIN1)
         AND  0FH
         LD   B,A
         IN   A,(MIN10)
         CALL SHIFTRTC
         AND  0F0H
         ADD  A,B
         LD   C,A        ;MIN

         IN   A,(DAY1)
         AND  0FH
         LD   B,A
         IN   A,(DAY10)
         CALL SHIFTRTC
         AND  0F0H
         ADD  A,B
         LD   H,A        ;DAY

         IN   A,(MON1)
         AND  0FH
         LD   B,A
         IN   A,(MON10)
         CALL SHIFTRTC
         AND  0F0H
         ADD  A,B
         LD   L,A        ;MON

         IN   A,(YEAR1)
         AND  0FH
         LD   B,A
         IN   A,(YEAR10)
         CALL SHIFTRTC
         AND  0F0H
         ADD  A,B
         LD   E,A        ;YEAR

         IN   A,(HOUR1)
         AND  0FH
         LD   B,A
         IN   A,(HOUR10)
         CALL SHIFTRTC
         AND  0F0H
         ADD  A,B
         LD   B,A        ;HOUR
         RET
;
;******** RTC INT *****
;
INTRTC:  LD   A,04H          ;set 24h
         OUT  (CREG_F),A
         XOR  A
         OUT  (CREG_D),A     ;set HOLD bit=0
         RET
;
;******** RTC INT 1 SEC *****
;
INTRTC1S:LD   A,04H          ;set 24h
         OUT  (CREG_F),A
         OUT  (CREG_E),A     ;set INT  1sec
         XOR  A
         OUT  (CREG_D),A     ;set HOLD bit=0
         RET
;
;
SHIFTRTC: RLCA
          RLCA
          RLCA
          RLCA
          RET
;

;
SHIPL:   RRCA
         RRCA
         RRCA
         RRCA
         RET
;
;******** SUB OUT WDT *******
;
         .EQU CSWDT,0E0H
;
WDT:     PUSH AF
         IN   A,(CSWDT)
         POP  AF
         RET
;

         .END
