;****************************
;* Demo Program For ET-SDP8 *
;* Assembler : A180Z        *
;* Hardware : CP-JR180 V2.0 *
;****************************

            .ORG     8000H

            .EQU     PA_8255,60H
            .EQU     PB_8255,61H
            .EQU     PC_8255,62H
            .EQU     PCC_8255,63H
            .EQU     CLK,4           ; PB4
            .EQU     DIN,5           ; PB5
            .EQU     LOAD,6          ; PB6

;****************
;* Main Program *
;****************
;
MAIN:       LD      A,80H
            OUT     (PCC_8255),A
            CALL    INIT_MAX
;

LOOP:       LD      B,8
            LD      HL,DSP_BUFF
INIT_DSP:   LD      A,0
            LD      (HL),A
            INC     HL
            DEC     B
            JP      NZ,INIT_DSP
            ;
DIGIT0:     CALL    DSP_DATA
            CALL    DELAY
            LD      HL,DSP_BUFF+0
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT1:     LD      HL,DSP_BUFF+1
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT2:     LD      HL,DSP_BUFF+2
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT3:     LD      HL,DSP_BUFF+3
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT4:     LD      HL,DSP_BUFF+4
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT5:     LD      HL,DSP_BUFF+5
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT6:     LD      HL,DSP_BUFF+6
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            ;
DIGIT7:     LD      HL,DSP_BUFF+7
            INC     (HL)
            LD      A,(HL)
            CP      0AH
            JP      NZ,DIGIT0
            LD      A,0
            LD      (HL),A
            JP      LOOP

;****************************
;* Display MAX7219  8 Digit *
;* Input : DSP_BUFF(0-9,FF) *
;****************************
;
DSP_DATA:   LD      B,8
            LD      C,1
            LD      IX,DSP_BUFF
DSP_1:      LD      A,(IX+0)
            CALL    CONV_DSP
            LD      H,C
            LD      L,A
            CALL    SHIFTM
            INC     IX
            INC     C
            DEC     B
            JP      NZ,DSP_1
            RET

;********************************
;* Shift Data 16 Bit to MAX7219 *
;* Input : Register H = Address *
;*       : Register L = Data    *
;********************************
;

SHIFTM:      PUSH    BC
            LD      B,8
            LD      A,H
SHIFT1:     RLC     A
            LD      (RLCA_BUF),A
            LD      A,(DSP_SIGN)
            JP      C,SHF11
            RES     DIN,A
            OUT     (PB_8255),A
            JP      SHF12
SHF11:      SET     DIN,A
            OUT     (PB_8255),A
SHF12:      RES     CLK,A
            OUT     (PB_8255),A
            SET     CLK,A
            OUT     (PB_8255),A
            LD      (DSP_SIGN),A
            LD      A,(RLCA_BUF)
            DEC     B
            JP      NZ,SHIFT1
            LD      B,8
            LD      A,L
SHIFT2:     RLC     A
            LD      (RLCA_BUF),A
            LD      A,(DSP_SIGN)
            JP      C,SHF21
            RES     DIN,A
            OUT     (PB_8255),A
            JP      SHF22
SHF21:      SET     DIN,A
            OUT     (PB_8255),A
SHF22:      RES     CLK,A
            OUT     (PB_8255),A
            SET     CLK,A
            OUT     (PB_8255),A
            LD      (DSP_SIGN),A
            LD      A,(RLCA_BUF)
            DEC     B
            JP      NZ,SHIFT2
            LD      A,(DSP_SIGN)
            RES     LOAD,A
            OUT     (PB_8255),A
            SET     LOAD,A
            OUT     (PB_8255),A
            LD      (DSP_SIGN),A
            POP     BC
            RET

;*******************
;* Initial MAX7219 *
;*******************
;
INIT_MAX:   LD      HL,0A08H            ; Intensity (Middle)
            CALL    SHIFTM
            LD      HL,0B07H            ; Scan Limitt (8-digit)
            CALL    SHIFTM
            LD      HL,0900H            ; Set Mode (No Decode BCD)
            CALL    SHIFTM
            LD      HL,0C01H            ; Not Shutdown (Normal Opr.)
            CALL    SHIFTM
            LD      HL,0F00H            ; Not Display Test (Normal Opr.)
            CALL    SHIFTM
            RET

;*****************************
;* Convert Number to Display *
;* Input  : ACC (0-9,FFH)    *
;* Output : ACC (Dsp Code)   *
;*****************************
;
CONV_DSP:   CP      0FFH
            JP      NZ,PACK_DP1
            LD      A,00H
            JP      PACK_DP2
PACK_DP1:   LD      HL,TAB_SEG
            LD      D,0
            LD      E,A
            ADD     HL,DE
            LD      A,(HL)
PACK_DP2:   RET

;*******************
;* Table 7 Segment *
;*******************
;
TAB_SEG:    .DB     7EH,30H,6DH,79H     ; 0 1 2 3
            .DB     33H,5BH,5FH,70H     ; 4 5 6 7
            .DB     7FH,7BH             ; 8 9

;**************
;* Delay Time *
;**************
;
DELAY:      PUSH    AF
            PUSH    HL
            LD      HL,4000H
DEL1:       DEC     HL
            LD      A,H
            OR      L
            JP      NZ,DEL1
            POP     HL
            POP     AF
            RET
;
TEST:       LD      A,80H
            RST     10H

;**************
;* RAM Buffer *
;**************
;
RLCA_BUF:   .RS     1                   ; Buffer Rotate Bit
DSP_SIGN:   .RS     1                   ; MAX7219 Signal (DIN,LOAD,CLK)
DSP_BUFF:   .RS     8                   ; Display Buffer

            .END


